"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const package_json_1 = require("../../package.json");
const client = require("cheerio-httpcli");
client.set('headers', {
    'User-Agent': `${package_json_1.name}/${package_json_1.version}`
});
client.set('referer', false);
client.set('timeout', 10000);
function test(url) {
    return url.hostname === 'www.amazon.com' ||
        url.hostname === 'www.amazon.co.jp' ||
        url.hostname === 'www.amazon.ca' ||
        url.hostname === 'www.amazon.com.br' ||
        url.hostname === 'www.amazon.com.mx' ||
        url.hostname === 'www.amazon.co.uk' ||
        url.hostname === 'www.amazon.de' ||
        url.hostname === 'www.amazon.fr' ||
        url.hostname === 'www.amazon.it' ||
        url.hostname === 'www.amazon.es' ||
        url.hostname === 'www.amazon.nl' ||
        url.hostname === 'www.amazon.cn' ||
        url.hostname === 'www.amazon.in' ||
        url.hostname === 'www.amazon.au';
}
exports.test = test;
function summarize(url) {
    return __awaiter(this, void 0, void 0, function* () {
        const res = yield client.fetch(url.href);
        const $ = res.$;
        const title = $('#title').text();
        const description = $('#productDescription').text() ||
            $('meta[name="description"]').attr('content');
        const thumbnail = $('#landingImage').attr('src');
        const playerUrl = $('meta[property="twitter:player"]').attr('content') ||
            $('meta[name="twitter:player"]').attr('content');
        const playerWidth = parseInt($('meta[property="twitter:player:width"]').attr('content') ||
            $('meta[name="twitter:player:width"]').attr('content'));
        const playerHeight = parseInt($('meta[property="twitter:player:height"]').attr('content') ||
            $('meta[name="twitter:player:height"]').attr('content'));
        return {
            title: title || null,
            icon: 'https://www.amazon.com/favicon.ico',
            description: description || null,
            thumbnail: thumbnail || null,
            player: {
                url: playerUrl || null,
                width: playerWidth || null,
                height: playerHeight || null
            },
            sitename: 'Amazon'
        };
    });
}
exports.summarize = summarize;
